// Code generated by protoc-gen-validate. DO NOT EDIT.
// source: config/service/auditsink/slack/v1/slack.proto

package slackv1

import (
	"bytes"
	"errors"
	"fmt"
	"net"
	"net/mail"
	"net/url"
	"regexp"
	"strings"
	"time"
	"unicode/utf8"

	"github.com/golang/protobuf/ptypes"
)

// ensure the imports are used
var (
	_ = bytes.MinRead
	_ = errors.New("")
	_ = fmt.Print
	_ = utf8.UTFMax
	_ = (*regexp.Regexp)(nil)
	_ = (*strings.Reader)(nil)
	_ = net.IPv4len
	_ = time.Duration(0)
	_ = (*url.URL)(nil)
	_ = (*mail.Address)(nil)
	_ = ptypes.DynamicAny{}
)

// define the regex for a UUID once up-front
var _slack_uuidPattern = regexp.MustCompile("^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$")

// Validate checks the field values on SlackConfig with the rules defined in
// the proto definition for this message. If any rules are violated, an error
// is returned.
func (m *SlackConfig) Validate() error {
	if m == nil {
		return nil
	}

	if len(m.GetToken()) < 1 {
		return SlackConfigValidationError{
			field:  "Token",
			reason: "value length must be at least 1 bytes",
		}
	}

	if len(m.GetChannel()) < 1 {
		return SlackConfigValidationError{
			field:  "Channel",
			reason: "value length must be at least 1 bytes",
		}
	}

	if v, ok := interface{}(m.GetFilter()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return SlackConfigValidationError{
				field:  "Filter",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	return nil
}

// SlackConfigValidationError is the validation error returned by
// SlackConfig.Validate if the designated constraints aren't met.
type SlackConfigValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e SlackConfigValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e SlackConfigValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e SlackConfigValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e SlackConfigValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e SlackConfigValidationError) ErrorName() string { return "SlackConfigValidationError" }

// Error satisfies the builtin error interface
func (e SlackConfigValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sSlackConfig.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = SlackConfigValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = SlackConfigValidationError{}
