// Code generated by protoc-gen-validate. DO NOT EDIT.
// source: config/service/k8s/v1/k8s.proto

package k8sv1

import (
	"bytes"
	"errors"
	"fmt"
	"net"
	"net/mail"
	"net/url"
	"regexp"
	"strings"
	"time"
	"unicode/utf8"

	"github.com/golang/protobuf/ptypes"
)

// ensure the imports are used
var (
	_ = bytes.MinRead
	_ = errors.New("")
	_ = fmt.Print
	_ = utf8.UTFMax
	_ = (*regexp.Regexp)(nil)
	_ = (*strings.Reader)(nil)
	_ = net.IPv4len
	_ = time.Duration(0)
	_ = (*url.URL)(nil)
	_ = (*mail.Address)(nil)
	_ = ptypes.DynamicAny{}
)

// define the regex for a UUID once up-front
var _k_8_s_uuidPattern = regexp.MustCompile("^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$")

// Validate checks the field values on Config with the rules defined in the
// proto definition for this message. If any rules are violated, an error is returned.
func (m *Config) Validate() error {
	if m == nil {
		return nil
	}

	_Config_Kubeconfigs_Unique := make(map[string]struct{}, len(m.GetKubeconfigs()))

	for idx, item := range m.GetKubeconfigs() {
		_, _ = idx, item

		if _, exists := _Config_Kubeconfigs_Unique[item]; exists {
			return ConfigValidationError{
				field:  fmt.Sprintf("Kubeconfigs[%v]", idx),
				reason: "repeated value must contain unique items",
			}
		} else {
			_Config_Kubeconfigs_Unique[item] = struct{}{}
		}

		// no validation rules for Kubeconfigs[idx]
	}

	if v, ok := interface{}(m.GetRestClientConfig()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return ConfigValidationError{
				field:  "RestClientConfig",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	return nil
}

// ConfigValidationError is the validation error returned by Config.Validate if
// the designated constraints aren't met.
type ConfigValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e ConfigValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e ConfigValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e ConfigValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e ConfigValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e ConfigValidationError) ErrorName() string { return "ConfigValidationError" }

// Error satisfies the builtin error interface
func (e ConfigValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sConfig.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = ConfigValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = ConfigValidationError{}

// Validate checks the field values on RestClientConfig with the rules defined
// in the proto definition for this message. If any rules are violated, an
// error is returned.
func (m *RestClientConfig) Validate() error {
	if m == nil {
		return nil
	}

	if d := m.GetTimeout(); d != nil {
		dur, err := ptypes.Duration(d)
		if err != nil {
			return RestClientConfigValidationError{
				field:  "Timeout",
				reason: "value is not a valid duration",
				cause:  err,
			}
		}

		gte := time.Duration(0*time.Second + 0*time.Nanosecond)

		if dur < gte {
			return RestClientConfigValidationError{
				field:  "Timeout",
				reason: "value must be greater than or equal to 0s",
			}
		}

	}

	if m.GetQps() < 0 {
		return RestClientConfigValidationError{
			field:  "Qps",
			reason: "value must be greater than or equal to 0",
		}
	}

	if m.GetBurst() < 0 {
		return RestClientConfigValidationError{
			field:  "Burst",
			reason: "value must be greater than or equal to 0",
		}
	}

	return nil
}

// RestClientConfigValidationError is the validation error returned by
// RestClientConfig.Validate if the designated constraints aren't met.
type RestClientConfigValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e RestClientConfigValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e RestClientConfigValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e RestClientConfigValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e RestClientConfigValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e RestClientConfigValidationError) ErrorName() string { return "RestClientConfigValidationError" }

// Error satisfies the builtin error interface
func (e RestClientConfigValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sRestClientConfig.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = RestClientConfigValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = RestClientConfigValidationError{}
